package modules.states;

import utils.BotInfo;
import utils.BotInfoMap;
import bots.TemplateBot;

public class MuteStateManager extends TemplateStateModule {
	/**
	 * Default constructor for MuteStateManager
	 * @param owner Bot which owns this module
	 * @param bots BotInfoMap which has all information recorded by bot
	 */
	public MuteStateManager(TemplateBot owner, BotInfoMap bots) {
		super(owner, bots);
	}
	/* (non-Javadoc)
	 * @see modules.EmptyModule#move()
	 */
	public void move() {
		BotInfo bot;
		String target=owner.getTarget();
		int[] state=owner.getState();
		BotInfoMap bots=owner.getBots();
		if(state==ATTACK_ALL){//attack all state
			if(owner.getEnergy()>LOW_ENERGY){
				bot=bots.getNearestBot(owner,false,LOW_ENERGY,MAX_INFO_AGE);//looking for friends needing help
				if(bot!=null)
					owner.setState(DEFEND_BOT,bot.getName());
				else{
					bot=bots.getNearestBot(owner,true,Double.MAX_VALUE,MAX_INFO_AGE);//looking for enemies with low energy
					if(bot!=null)
						owner.setState(ATTACK_BOT,bot.getName());
				}
			}
		}
		else if(state==ATTACK_BOT){//attack bot state
			owner.out.println("Check, target:"+owner.getTarget()+"\tcontains:"+bots.containsInfo(owner.getTarget()));
			if(owner.getEnergy()<=LOW_ENERGY				//low energy 
					||!bots.containsInfo(owner.getTarget()))//or target dead
				owner.setState(ATTACK_ALL,null);
			else{
				bot=bots.getNearestBot(owner,false,LOW_ENERGY,MAX_INFO_AGE);//looking for friends needing help
				if(bot!=null)
					owner.setState(DEFEND_BOT,bot.getName());
			}
		}
		else if(state==DEFEND_BOT){//defend bot state
			if(owner.getEnergy()<=LOW_ENERGY) //own energy low
				owner.setState(ATTACK_ALL,null);
			else{
				if(!bots.containsInfo(target)|| //defended bot dead
						((BotInfo)bots.getInfo(target)).getEnergy()>LOW_ENERGY){ //or defended bot doesn't need help anymore
					bot=bots.getNearestBot(owner,true,Double.MAX_VALUE,MAX_INFO_AGE);//looking for enemies with low energy
					if(bot!=null)
						owner.setState(ATTACK_BOT,bot.getName());
					else owner.setState(ATTACK_ALL,null);
				}
			}
		}
		else owner.setState(ATTACK_ALL,null);
	}
}