package modules.states;

import modules.EmptyModule;
import modules.GunModule;
import modules.MovementModule;
import modules.RadarModule;
import utils.BotInfoMap;
import bots.TemplateBot;

public abstract class TemplateStateModule extends EmptyModule {
	/**
	 * Unique state available
	 */
	public static final int DEFAULT_MODE=1;
	protected static final double LOW_ENERGY=30;
	protected static final long MAX_INFO_AGE=10;
	/**
	 * Attack all state
	 */
	public static int[] ATTACK_ALL={RadarModule.SCANNING_MODE,MovementModule.RANDOM_MODE,GunModule.ATTACK_ALL_MODE,TemplateStateModule.DEFAULT_MODE};
	/**
	 * Attack bot state
	 */
	public static int[] ATTACK_BOT={RadarModule.TRACKING_MODE,MovementModule.FOLLOW_MODE,GunModule.ATTACK_BOT_MODE,TemplateStateModule.DEFAULT_MODE};
	/**
	 * Defend bot state
	 */
	public static int[] DEFEND_BOT={RadarModule.SCANNING_MODE,MovementModule.FOLLOW_MODE,GunModule.ATTACK_ALL_MODE,TemplateStateModule.DEFAULT_MODE};
	/**
	 * Default constructor for TemplateStateModule
	 * @param owner Bot which owns this module
	 * @param bots BotInfoMap which has all information recorded by bot
	 */
	public TemplateStateModule(TemplateBot owner, BotInfoMap bots) {
		super(owner, bots);
	}
	/* (non-Javadoc)
	 * @see modules.EmptyModule#move()
	 */
	public abstract void move();
}